clear
close all

%% Power spectral Density of PPM UWB signals

%% Checkpoint 3-1
%% S1
avg_pow     = -30; %dBm
smp_freq    = 1e11;
num_pulses  = 1e4;
pulse_width = 0.5e-9;
frame_size  = 2e-9;
max_shift   = 0;
carrier_mod = 0;

[S1, pulse1, dt1] = PPM_det(frame_size, num_pulses, max_shift, pulse_width, carrier_mod, avg_pow, smp_freq);
pulse1_tf=zeros(1,length(S1));
pulse1_tf(round(length(S1)/2)-round(length(pulse1)/2):round(length(S1)/2)+length(pulse1)-round(length(pulse1)/2)-1)=pulse1;
[PSD1, df1, freq_axis_1,fh] = PSD(S1,smp_freq);
%This part is added to plot the sin(x)/x envelope
hold on
[PSD1_env, df1_env, freq_axis_1_env,fh_env1] = PSD(pulse1_tf,smp_freq);
close(fh_env1)
%set(fh,'InnerPosition',[1000 918 845 394]);
plot(freq_axis_1_env,(PSD1_env/max(PSD1_env))*(max(PSD1)),'r--','LineWidth',2)
axis([-3/pulse_width,3/pulse_width,0,1.05*max(PSD1)])
grid on
%pause



%% S2

max_shift   = 1e-9;
carrier_mod = 5e7;

[S2, pulse2,dt2] = PPM_det(frame_size, num_pulses, max_shift, pulse_width, carrier_mod, avg_pow, smp_freq);
pulse2_tf=zeros(1,length(S2));
pulse2_tf(round(length(S2)/2)-round(length(pulse2)/2):round(length(S2)/2)+length(pulse2)-round(length(pulse2)/2)-1)=pulse2;
[PSD2, df2, freq_axis_2,fh] = PSD(S2,smp_freq);
%This part is added to plot the sin(x)/x envelope
hold on
[PSD2_env, df2_env, freq_axis_2_env,fh_env2] = PSD(pulse2_tf,smp_freq);
close(fh_env2)
%set(fh,'InnerPosition',[1000 918 845 394]);
plot(freq_axis_2_env,(PSD2_env/max(PSD2_env))*(max(PSD2)),'r--','LineWidth',2)
axis([-3/pulse_width,3/pulse_width,0,1.05*max(PSD2)])
grid on
%close all
pause;

%% Checkpoint 3-3
sigma=0.1e-9;

%This section is used to generate the pdf of delays 
%with and without the clipping 
upperLimit=(frame_size -pulse_width);
upperLimitVec=upperLimit*ones(1,num_pulses);
lowerLimit=zeros(1,num_pulses);
unboundedDelays = sigma.*randn(1,num_pulses)+3*frame_size/8;
uLViolations=find(unboundedDelays>upperLimit);
lLViolations=find(unboundedDelays<lowerLimit);
numUlViolations=length(uLViolations);
numLlViolations=length(lLViolations);
delays=unboundedDelays;
delays(uLViolations)=upperLimit;
delays(lLViolations)=0;
meanUnbounded=mean(unboundedDelays);
meanBounded=mean(delays);

[S3, dt3, m] = PPM_rndn(frame_size, num_pulses, sigma, pulse_width, avg_pow, smp_freq);
NI = round((8*frame_size)/dt3);
figure()
h = histogram(m,NI,'Normalization','pdf');
xlabel('time')
ylabel('pdf')
title('New')
figure()
h_bounded=histogram(delays,NI,'Normalization','pdf');
xlabel('time')
ylabel('pdf')
title('Book')
figure()
h_unbounded=histogram(unboundedDelays,NI,'Normalization','pdf');
xlabel('time')
ylabel('pdf')
title('Book UB')
h_data=h.Values;
h_data=h_data/sum(h_data);
h_long=zeros(1,length(S3));
h_long(round(length(S3)/2)-round(length(h_data)/2):round(length(S3)/2)+length(h_data)-round(length(h_data)/2)-1)=h_data;
[PSD3, df3,freq_axis_3,fh] = PSD(S3,smp_freq);

%pause;
%set(fh,'InnerPosition',[1000 918 845 394]);
%axis([-3/pulse_width,3/pulse_width,0,1.05*max(PSD3)])

freq_axis=linspace(-smp_freq/2,smp_freq/2,length(PSD3));

grid on
hold on
plot(freq_axis,((PSD2_env)/(max(PSD2_env)))*max(PSD3),'r:','LineWidth',2)
theoretical_W=exp(-(pi^2*(freq_axis.^2)*sigma^2));
theoretical_W2=theoretical_W.*theoretical_W;
plot(freq_axis,(theoretical_W2/max(theoretical_W2))*max(PSD3),'c--','LineWidth',2)
plot(freq_axis,((theoretical_W2/max(theoretical_W2)).*((PSD2_env)/(max(PSD2_env))))*max(PSD3),'m--','LineWidth',2)
axis([-3/pulse_width,3/pulse_width,0,1.05*max(PSD3)])
lh=legend('Signal PSD','|P(f)|^2','|W_{th}(f)|^2','|P(f)|^2|W_{th}(f)|^2');
set(lh,'FontSize',12)
set(lh,'Location','East')
titlestr=sprintf('\\sigma=%1.2fe-9',sigma*1e9);
title(titlestr)
pause
%end
%% Checkpoint 3-4
% 1) Use functions for generating the PPM-TH signal
% 2) Apply the function "PSD" the the PPM-TH generated signal in order to check the frequency domain.

powdBm = -30;
fs = 30e9;
nBits = 10;
Ns = 5;
Tf = 5e-9;
Tc = 1e-9;
Nh = 5;
Np = 5;
Tm = 0.9e-9;
tau = 0.2e-9;
dPPM =0.25e-9;

%Case 1 - no PPM shift, no TH code
[data1, c1, PPM_TH_signal_1, TH_signal_1]  = TX_BPPM_TH(nBits, Ns,fs, Tc, Tf, 1, 1,0, Tm, tau, powdBm);
[PSD_PPM_TH_1, df1,frequency,fh] = PSD(PPM_TH_signal_1,fs);
hold on
p = gaussian_wf(fs, Tm, tau, 2);
p_tf=zeros(1,length(PPM_TH_signal_1));
p_tf(round(length(PPM_TH_signal_1)/2)-round(length(p)/2):round(length(PPM_TH_signal_1)/2)+length(p)-round(length(p)/2)-1)=p;
[PSD_pulse, df_pulse,frequency,fh_pulse]=PSD(p_tf,fs);
close(fh_pulse)
plot(frequency,(PSD_pulse/max(PSD_pulse))*(max(PSD_PPM_TH_1)),'r--','LineWidth',2)
title('No PPM, no TH code')
%Case 2 - no PPM shift,TH code
[data2, c2, PPM_TH_signal_2, TH_signal_2]  = TX_BPPM_TH(nBits, Ns,fs, Tc, Tf, Np, Nh,0, Tm, tau, powdBm);
[PSD_PPM_TH_2, df2] = PSD(PPM_TH_signal_2,fs);
hold on
plot(frequency,(PSD_pulse/max(PSD_pulse))*(max(PSD_PPM_TH_1)),'r--','LineWidth',2)
title('No PPM, TH code')
%Case 3 - PPM shift,TH code
[data3, c3, PPM_TH_signal_3, TH_signal_3]  = TX_BPPM_TH(nBits, Ns,fs, Tc, Tf, Np, Nh,dPPM, Tm, tau, powdBm);
[PSD_PPM_TH_3, df3] = PSD(PPM_TH_signal_3,fs);
hold on
plot(frequency,(PSD_pulse/max(PSD_pulse))*(max(PSD_PPM_TH_1)),'r--','LineWidth',2)
title('PPM, TH code')
%Impact of Np
Np=nBits;
[data4, c4, PPM_TH_signal_4, TH_signal_4]  = TX_BPPM_TH(nBits, Ns,fs, Tc, Tf, Np, Nh,dPPM, Tm, tau, powdBm);
[PSD_PPM_TH_4, df4] = PSD(PPM_TH_signal_4,fs);
hold on
plot(frequency,(PSD_pulse/max(PSD_pulse))*(max(PSD_PPM_TH_1)),'r--','LineWidth',2)
title('PPM, TH code (Np=nBits)')

