% -- PPM_det
function [signal, p, dt] = PPM_det(frame_size, num_pulses, max_shift, ...
    pulse_width, carrier_mod, avg_pow, smp_freq)

% input
Tf = frame_size;
np = num_pulses;
A = max_shift;
Tm = pulse_width;
fc = carrier_mod;
pow_dBm = avg_pow;
fs = smp_freq;

dt = 1/fs;
t = 0:dt:(np+1)*Tf;
x = zeros(1,length(t));

Tf_idx = round(Tf/dt); %samples in a frame

m = A*cos(2*pi*fc*(1:np)*Tf); % time-shifts
m_idx = ceil(m/dt); % idx-shifts

x((1:np)*Tf_idx + m_idx) = 1; % put a 1 @ each idx-shift

p = ones(1, round(Tm/dt));
pulse_energy= sum(p.^2).*dt;
 
pow = 10^(pow_dBm/10) * 1e-3; %Watt
% energy of rect is Tm so ratio over Tm is normalizing the pulse!
p = sqrt(pow*Tf/Tm) * p;

signal = conv(x,p);
signal = signal(1:length(t));

end