% -- PPM_rndn
function [signal, dt, m] = PPM_rndn(frame_size, num_pulses, sigma, ...
    pulse_width, avg_pow, smp_freq)

% input
Tf = frame_size;
np = num_pulses;
Tm = pulse_width;
pow_dBm = avg_pow;
fs = smp_freq;

% start
dt = 1/fs;
t = 0:dt:(np+1)*Tf;
x = zeros(1,length(t));

Tf_idx = round(Tf/dt);

m = sigma*randn(1,np); % time-shifts
m_idx = round(m/dt); % idx-shifts

x((1:np)*Tf_idx + m_idx) = 1;

p = ones(1, floor(Tm/dt));

pow = 10^(pow_dBm/10) * 1e-3;
p = sqrt(pow*Tf/Tm) * p;

signal = conv(x,p);
signal = signal(1:length(t));

end

%norm(signal)^2 * dt/Tf *1/np % verifying avg power




