%% -- PSD Evaluation
function [PSD, df, frequency,fh] = PSD(signal, fc)

dt=1/fc;
N=length(signal);
T=N*dt;
df=1/T;
X=fft(signal);
X=X/N;
mPSD=abs(X).^2/(df^2);
PSD=fftshift(mPSD);
PSD=(1/T).*PSD;

figure();
frequency = linspace(-fc/2, fc/2, length(PSD));
PF=plot(frequency,PSD);
set(PF, 'LineWidth',2);
AX=gca;
set(AX, 'FontSize',12);
X=xlabel('Frequency [Hz]');
set(X, 'FontSize',14);
Y=ylabel('PSD [V^2/Hz]');
set(Y, 'FontSize',14);
fh=gcf;