function h = hermite_coeff(n)
% HERMITE POLY PROB DEF: compute the coefficients of the n-order Hermite 
% polynomial assuming the probabilistic definition.
h = hermite_rec(n);

function h = hermite_rec(n)
% Recurrence:
%   H_0(x) = 1
%   H_1(x) = x
%   H_[n+1](x) = x Hn(x) - n H[n-1](x)

if n==0 
    h = 1;
elseif n==1
    h = [1 0];
else    
    h1 = zeros(1,n+1);
    h1(1:n) = hermite_rec(n-1);
    
    h2 = zeros(1,n+1);
    h2(3:end) = (n-1)*hermite_rec(n-2);
    
    h = h1 - h2; 
end